<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for eventHistoryType StructType
 * @subpackage Structs
 */
class EventHistoryType extends AbstractStructBase
{
    /**
     * The eventData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\EventDataType[]
     */
    public $eventData;
    /**
     * Constructor method for eventHistoryType
     * @uses EventHistoryType::setEventData()
     * @param \StructType\EventDataType[] $eventData
     */
    public function __construct(array $eventData = array())
    {
        $this
            ->setEventData($eventData);
    }
    /**
     * Get eventData value
     * @return \StructType\EventDataType[]|null
     */
    public function getEventData()
    {
        return $this->eventData;
    }
    /**
     * This method is responsible for validating the values passed to the setEventData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEventData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEventDataForArrayConstraintsFromSetEventData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $eventHistoryTypeEventDataItem) {
            // validation for constraint: itemType
            if (!$eventHistoryTypeEventDataItem instanceof \StructType\EventDataType) {
                $invalidValues[] = is_object($eventHistoryTypeEventDataItem) ? get_class($eventHistoryTypeEventDataItem) : sprintf('%s(%s)', gettype($eventHistoryTypeEventDataItem), var_export($eventHistoryTypeEventDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The eventData property can only contain items of type \StructType\EventDataType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set eventData value
     * @throws \InvalidArgumentException
     * @param \StructType\EventDataType[] $eventData
     * @return \StructType\EventHistoryType
     */
    public function setEventData(array $eventData = array())
    {
        // validation for constraint: array
        if ('' !== ($eventDataArrayErrorMessage = self::validateEventDataForArrayConstraintsFromSetEventData($eventData))) {
            throw new \InvalidArgumentException($eventDataArrayErrorMessage, __LINE__);
        }
        $this->eventData = $eventData;
        return $this;
    }
    /**
     * Add item to eventData value
     * @throws \InvalidArgumentException
     * @param \StructType\EventDataType $item
     * @return \StructType\EventHistoryType
     */
    public function addToEventData(\StructType\EventDataType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EventDataType) {
            throw new \InvalidArgumentException(sprintf('The eventData property can only contain items of type \StructType\EventDataType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->eventData[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\EventHistoryType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
